/********************************************************************************
 * Info PA non fa altro che scrivere nel ring-buffer del kernel gli indirizzi
 * dei registri:
 *   R_PORT_PA_SET, R_PORT_PA_DATA, R_PORT_PA_DIR
 * e i loro rispettivi contenuti
 * Version:  0.1
 * Author:   Calzo
 * Arch:     AXIS ETRAX 100 LX Risc 32 bit processor
 * License:  DUAL BSD/GPL
 * ------------------------------------------------------------------------------
 * Questo modulo non ha bisogno di un file di interfaccia in /dev
 * ------------------------------------------------------------------------------
 * NOTE: 
 * ******************************************************************************/

#include <linux/module.h>
#include <asm/io.h>        //provide access to GPIO port and other peripherals on ETRAX100LX

MODULE_LICENSE("DUAL GPL/BSD");
MODULE_VERSION("0.1");

/****************************************
 * INITIALIZATION & CLEANUP functions
 ****************************************/
/** Funzione di scaricamento del modulo
 *  * */
void infoPA_cleanup_module(void)
{
   // Non devo fare nulla
}

/** Funzione di inizializzazione del modulo
 * */
int infoPA_init_module(void)
{
   // Il cast a int serve solo per evitare dei warning in fase di compilazione
   printk(KERN_ALERT "\nIndirizzi della porta PA:\n - R_PORT_PA_SET  = %8X\n - R_PORT_PA_DATA = %8X\n - R_PORT_PA_DIR  = %8X\n",
	  (int)R_PORT_PA_SET, (int)R_PORT_PA_DATA, (int)R_PORT_PA_DIR);
   printk(KERN_ALERT "\nValori della porta PA:\n - R_PORT_PA_SET  = %8X\n - R_PORT_PA_DATA = %8X\n - R_PORT_PA_DIR  = %8X\n",
	  *R_PORT_PA_SET, *R_PORT_PA_DATA, *R_PORT_PA_DIR);
   *R_IRQ_MASK1_SET = 0x0F;
   printk(KERN_ALERT "R_IRQ_MASK1_SET__pa0__BITNR: %X\n\n", R_IRQ_MASK1_SET__pa0__BITNR);
   
   return 0;
}

/***************************************
 * INIT & EXIT
 ***************************************/
module_init(infoPA_init_module);
module_exit(infoPA_cleanup_module);
